<?php

define("MAX_PAGES", 50);

define("PREGS_FOLDER", "pregs");
define("RESULTS_FOLDER", "results");

define("ITEMS_FILE", "items.txt");

define("REGEXP_FILE", "regexp.txt");
define("PAGES_REGEXP_FILE", "pagesRegexp.txt");
define("START_URL_FILE", "startUrl.txt");

define("USER_AGENT", "Mozilla/4.0 (compatible; MSIE 5.01; Widows NT)");

$system = $_SERVER['argv'][1];
$parametr = $_SERVER['argv'][2];

function curlGetPost($url, $referer = null, $postContent = false, $init = false, $followLocation = true)
{
	if ($init || !isset($ch)) $ch = curl_init();

	curl_setopt($ch, CURLOPT_URL, $url);

	curl_setopt($ch, CURLOPT_FOLLOWLOCATION, $followLocation);
	curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
	curl_setopt($ch, CURLOPT_MAXREDIRS, 5);

	if ($referer) curl_setopt($ch, CURLOPT_REFERER, $referer);

	curl_setopt($ch, CURLOPT_USERAGENT, USER_AGENT);

	if ($postContent)
	{
		curl_setopt($ch, CURLOPT_POST, 1);
		curl_setopt($ch, CURLOPT_POSTFIELDS, $postContent);
	}
	else
	{
		curl_setopt($ch, CURLOPT_POST, false);
	}

	if (strtolower(substr($url, 0, 5)) == 'https') {
		curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, FALSE);
		curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, 2);
	}

	curl_setopt($ch, CURLOPT_COOKIEFILE, "cooks.txt");

	return curl_exec($ch);
}

function getAbsUrl($page, $link)
{
	$page = trim($page);
	$link = trim($link);

	if (strpos($link, "#") !== false) $link = substr($link, 0, strpos($link, "#"));
	if (strpos($page, "?") !== false) $page = substr($page, 0, strrpos($page, "?"));

	if (strtolower(substr($link, 0, 7)) == "http://") return $link;
	if (strtolower(substr($link, 0, 8)) == "https://") return $link;
	if (strtolower(substr($link, 0, 4)) == "www.") return "http://".$link;

	if (strtolower(substr($link, 0, 7)) == "mailto:") return false;
	if (strtolower(substr($link, 0, 11)) == "javascript:") return false;

	if (substr($link, 0, 1) == "/")
	{
		$url = parse_url($page);
		$url = "http://".$url['host'].$link;
	}
	elseif (substr($link, 0, 1) == "?")
	{
		$url = $page.$link;
	}
	else
	{
		$url = substr($page, 0, strrpos($page, "/")+1).$link;
	}

	while (strpos($url, "../") !== false)
	{
		$nstr = substr($url, 0, strpos($url, "../") - 1);
		$nstr = substr($nstr, 0, strrpos($nstr, "/")+1);
		if (substr($nstr, -2) == "//") return false;
		$url = $nstr.substr($url, strpos($url, "../") +3);
	}

	$url = str_replace("./", "", $url);

	return $url;
}

if (!file_exists($pregFolder = "./".PREGS_FOLDER."/".$system."/"))
{
	echo "Parser regular extension dont exists\n";
	exit;
}
else
{
	// 
	if (!file_exists($itemsFile = $pregFolder.ITEMS_FILE))
	{
		echo "Items file not exists\n";
		exit;
	} else echo "items - ok\n";
	$items = file_get_contents($itemsFile);

	//  
	if (!file_exists($regexpFile = $pregFolder.REGEXP_FILE))
	{
		echo "Regexp file not exists\n";
		exit;
	} else echo "regexp - ok\n";
	$regexp = file_get_contents($regexpFile);

	//   
	if (!file_exists($pagesRegexpFile = $pregFolder.PAGES_REGEXP_FILE))
	{
		echo "Pages regexp file not exists\n";
		exit;
	} else echo "pages - ok\n";
	$pagesRegexp = file_get_contents($pagesRegexpFile);
	
	// 
	if (!file_exists($startUrlFile = $pregFolder.START_URL_FILE))
	{
		echo "Start url file not exists\n";
		exit;
	} else echo "start page - ok\n";
	
	$startUrl = str_replace("@PARAMETR@", urlencode($parametr), file_get_contents($startUrlFile));
	
	$tackt = 0;
	
	$fp = fopen("./".RESULTS_FOLDER."/result_".date("Ymd-His").".txt", 'w');
	
	$url = $startUrl;
	
	$grabAll = 0;

	do
	{
		$tackt++;

		$content = curlGetPost($url, $url);
		
		if ($grab = preg_match_all("/".$regexp."/iUs", $content, $result))
		{
			unset($result[0]);
			
			foreach ($result[1] as $key => $value)
			{
				$source = trim($items);

				foreach ($result as $lineKey => $lineValue)
				{
					$source = str_replace("@".$lineKey."@", $result[$lineKey][$key], $source);
				}

				fwrite($fp, $source."\n");
			}
			
			$grabAll += $grab;
			
			echo "Tackt ".$tackt.", grab:".$grab.", all: ".$grabAll."\n";
		}
		else
		{
			echo "Tackt ".$tackt.", current empty, all: ".$grabAll."\n";
		}
		
		if (!preg_match("/".$pagesRegexp."/iUs", $content, $result))
		{
			echo "Parsing ends, next page not found, tackt: ".$tackt."\n";
			fclose($fp);
			exit;
		}
		else
		{
			$url = getAbsUrl($url, $result[1]);
		}

	} while ($tackt <= MAX_PAGES);
}